"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const azure_function_express_1 = require("azure-function-express");
let handler;
class AzureHttpAdapterStatic {
    handle(createApp, context, req) {
        if (handler) {
            return handler(context, req);
        }
        this.createHandler(createApp).then(fn => fn(context, req));
    }
    createHandler(createApp) {
        return __awaiter(this, void 0, void 0, function* () {
            const app = yield createApp();
            const instance = app.getHttpAdapter().getInstance();
            handler = azure_function_express_1.createHandler(instance);
            return handler;
        });
    }
}
exports.AzureHttpAdapterStatic = AzureHttpAdapterStatic;
exports.AzureHttpAdapter = new AzureHttpAdapterStatic();
